HDU - 5045 Contest(DP+状压)

Problem Description
In the ACM International Collegiate Programming Contest, each team consist of three students. And the teams are given 5 hours to solve between 8 and 12 programming problems. 

On Mars, there is programming contest, too. Each team consist of N students. The teams are given M hours to solve M programming problems. Each team can use only one computer, but they can’t cooperate to solve a problem. At the beginning of the ith hour, they will get the ith programming problem. They must choose a student to solve this problem and others go out to have a rest. The chosen student will spend an hour time to program this problem. At the end of this hour, he must submit his program. This program is then run on test data and can’t modify any more. 

Now, you have to help a team to find a strategy to maximize the expected number of correctly solved problems. 

For each problem, each student has a certain probability that correct solve. If the i th student solve the j th problem, the probability of correct solve is P ij .

At any time, the different between any two students’ programming time is not more than 1 hour. For example, if there are 3 students and there are 5 problems. The strategy {1,2,3,1,2}, {1,3,2,2,3} or {2,1,3,3,1} are all legal. But {1,1,3,2,3},{3,1,3,1,2} and {1,2,3,1,1} are all illegal. 

You should find a strategy to maximize the expected number of correctly solved problems, if you have know all probability
 

Input
The first line of the input is T (1 ≤ T ≤ 20), which stands for the number of test cases you need to solve.

The first line of each case contains two integers N ,M (1 ≤ N ≤ 10,1 ≤ M ≤ 1000),denoting the number of students and programming problem, respectively.

The next N lines, each lines contains M real numbers between 0 and 1 , the j th number in the i th line is P ij .
 

Output
For each test case, print a line “Case #t: ”(without quotes, t means the index of the test case) at the beginning. Then a single real number means the maximal expected number of correctly solved problems if this team follow the best strategy, to five digits after the decimal point. Look at the output for sample input for details.
 

Sample Input
  
  
1 2 3 0.6 0.3 0.4 0.3 0.7 0.9
 

Sample Output
  
  
Case #1: 2.20000

题意:每个人做题是有概率的,每个做题的序列任意两个人做题的个数不超过1,求最大的概率。
思路:设dp[i][j]表示前i道题,j的状态,因为不能超过1,所以每个状态我们都能用01表示,1表示当前做的题目最大,0表示最小的。例如3232,就表示1010,所以我们就能用1<<10的状态表示了,每次从0的人开始转移,因为只有0转移才能是符合条件的。

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int maxn = 1100;

double dp[maxn][maxn];
double p[maxn][maxn];

int main() {
    int n, m;
    int t, cas = 1;
    scanf("%d", &t);
    while (t--) {
        scanf("%d%d", &n, &m);        
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                scanf("%lf", &p[i][j]);

        for (int i = 0; i <= m; i++)
            for (int j = 0; j <= (1<<n); j++)
                dp[i][j] = -1.0;

        dp[0][0] = 0;
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < (1<<n); j++) {
                if (dp[i][j] < 0) continue;
                int st;
                for (int k = 0; k < n; k++) 
                    if (((1<<k)&j) == 0) {
                        st = j | (1<<k); 
                        if (st == (1<<n)-1) st = 0;
                        if (dp[i+1][st] < dp[i][j] + p[k][i])
                            dp[i+1][st] = dp[i][j] + p[k][i];
                    }
            }
        }

        double ans = 0;
        for (int i = 0; i < (1<<n); i++)
            ans = max(ans, dp[m][i]);
        printf("Case #%d: %.5lf\n", cas++, ans);
    }
    return 0;
}



  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值